using namespace std;
#include "includestuff.h"
CRandom *ranptr; // Global pointer to object used for random no. generation

int main(int argc, char *argv[]){
  stringstream sst;
  sst << argv[1];
  string filename;
  sst >> filename;
  CParameter parm(filename);

  int nevents,ievent,nparts,ipart;
  Tpartinfo **newparts;
  ifstream infile;
  ofstream outfile;
  Treslist reslist;
  int AMAX=5+int(2*parm.AMAX); // Give some leeway for decays
  newparts=new Tpartinfo *[AMAX+1];
  for(ipart=0;ipart<=AMAX;ipart++){
    newparts[ipart]=new Tpartinfo();
  }  
  ranptr=new CRandom(-time(NULL));

  reslist.ReadResInfo();
  sst.clear();
  sst << "mc_results/Tkin" << parm.Tkinetic << "_Tchem" << parm.Tchem 
      << "_Vchem" << parm.Vchem << "_" 
      << parm.resonances_qualifier << ".tmp" << ends;
  sst >> filename;
  cout << "Will read phase space points from : " << filename << endl;
  infile.open(filename.c_str());
  infile >> nevents;
  cout << "n ensembles=" << nevents << endl;

  sst.clear();
  sst << "decay_results/Tkin" << parm.Tkinetic << "_Tchem" << parm.Tchem 
      << "_Vchem" << parm.Vchem << "_" << parm.resonances_qualifier 
      << ".tmp" << ends;
  filename.clear();
  sst >> filename;
  cout << "Will write phase space points to : " << filename << endl;
  outfile.open(filename.c_str());

  outfile << nevents << endl;
  for(ievent=0;ievent<nevents;ievent++){
    ReadAndDecay(infile,AMAX,nparts,newparts,reslist);
    WriteParts(outfile,nparts,newparts);
    if(10*(ievent+1)%nevents==0)
      cout << "Finished " << (ievent+1)*100.0/double(nevents) << "%" << endl;
  }
  infile.close();
  outfile.close();
}

#include "includestuff.cc"

