void getp(double T,double mass,double *p){
  const double PI=4.0*atan(1.0);
  double pmag,ctheta,stheta,phi,e;
  if(T/mass>0.1){
 TRY_AGAIN:
    pmag=-T*log(ranptr->ran()*ranptr->ran()*ranptr->ran());
    e=sqrt(mass*mass+pmag*pmag);
    if(ranptr->ran()>exp(-(e-pmag)/T)) goto TRY_AGAIN;
  }
  else{
    pmag=sqrt(3.0*mass*T)*ranptr->gauss();
    e=sqrt(pmag*pmag+mass*mass);
  }
  phi=2.0*PI*ranptr->ran();
  ctheta=1.0-2.0*ranptr->ran();
  stheta=sqrt(1.0-ctheta*ctheta);
  p[0]=e;
  p[1]=pmag*stheta*cos(phi);
  p[2]=pmag*stheta*sin(phi);
  p[3]=pmag*ctheta;
}
