double getomega_fixedmass(double mass,double temperature,double volume){
  double answer,mass2,mass3,mass4;
  double k0,k1,z,prefact;
  const double HBARC=197.326;
  const double HBARC3=HBARC*HBARC*HBARC;
  const double PI = 4.0*atan(1.0);

  mass3=mass*mass*mass;  
  z=mass/temperature;
  k0=bessk0(z);
  k1=bessk1(z);
  prefact=1.0/(2.0*PI*PI*HBARC3);
  answer=volume*prefact*mass3*(k0*z+2.0*k1)/(z*z);

  return answer;
}

double getminmass(int);
double getomega(double mass,double width,int id,
		double temperature,double volume){
  double answer,m,delm,minmass;
  double k0,k1,z,prefact;
  int im,nm;
  const double HBARC=197.326;
  const double HBARC3=HBARC*HBARC*HBARC;
  const double PI = 4.0*atan(1.0);
	
  if(width<1.0) answer=getomega_fixedmass(mass,temperature,volume);
  else{
    answer=0.0;
    minmass=getminmass(id);
    m=mass-4.0*width;
    nm=40;
    delm=8.0*width/double(nm);
    m=m-0.5*delm;
    for(im=0;im<nm;im++){
      m+=delm;
      if(m>minmass)
	answer+=getomega_fixedmass(m,temperature,volume)
	  *(delm/(2.0*PI))*width/(pow(m-mass,2)+0.25*width*width);
    }
  }
  //cout << "For m=" << mass << ", omega=" << answer << ", =? " << 
  //  getomega_fixedmass(mass,temperature,volume) << endl;
  return answer;
}

double getminmass(int id){
  double minmass;
  minmass=0.0;
  id=abs(id);
  if(id==113 || id==213 || id==223 || id==333) minmass=279.2;
  if(id==2224 || id==2214 || id==2114 || id==1114) minmass=1079.25;
  if(id==3224 || id==3214 || id==3114) minmass=1255.1;
  if(id==3324 || id==3314) minmass=3324.8;
  return minmass;
}

