using namespace std;
#include "includestuff.h"
CRandom *ranptr;

//----------------------------------------------------------------------
void mc(int nevents,double Tkinetic,charge& Q,double *Aprob,partition_function& F,
	particle_zoo &zoo,string filename);
void getp(double T,double mass,double *p);

int main(int argc, char *argv[]){
  stringstream sst;
  sst << argv[1];
  string filename;
  sst >> filename;
  CParameter parm(filename);

  ranptr=new CRandom(-time(NULL));
  double *Aprob;
  string infilestring,outfilestring;
  int nevents;
  charge Q;

  environment env={parm.Tchem,parm.Vchem};
  particle_zoo zoo(env);

  cout << "How many ensembles do you wish to MC?\n";
  cin >> nevents;

  sst.clear();
  sst << "partition_results/Z_T" << parm.Tchem << "_V" << parm.Vchem 
      << "_" << parm.resonances_qualifier << ".tmp" << ends;
  sst >> infilestring;
  cout << "Reading partition functions from file : " << infilestring << endl;
  partition_function F(zoo,infilestring);

  filename="../particleinfo/"+parm.resonances_qualifier+".dat";
  zoo.clear();
  zoo.read_from_file(filename,1); // re-reading because partition functions
  // data files don't include all particle info 

  //cout << "For MonteCarlo, what is total B, S and I3?\n";
  //cin >> Q.qb >> Q.qs >> Q.qiso;
  Q.qb=Q.qs=Q.qiso=0;
  
  Aprob=new double[F.its_max_A+1];
  F.calculate_Aprob(Q,Aprob);

  sst.clear();
  sst << "mc_results/Tkin" << parm.Tkinetic << "_Tchem" << parm.Tchem
      << "_Vchem" << parm.Vchem << "_" << parm.resonances_qualifier 
      << ".tmp" << ends;
  sst >> outfilestring;
  cout << "Phase space points will be written to : " << outfilestring << endl;
  mc(nevents,parm.Tkinetic,Q,Aprob,F,zoo,outfilestring);

}

#include "includestuff.cc"
