void Tstaracceptance::setup(){
  string filename;
  stringstream sst;
  ifstream infile;
  int ivertex,ieta;
  double eta,dndeta; // these are not stored
  double zvertexmaxweight;

  icentrality=0; // most central bin only

  NVERTEXBINS=10;
  zvertexweight=new double[NVERTEXBINS];
  zvertexweight[0]=0.081848;
  zvertexweight[1]=0.096890;
  zvertexweight[2]=0.095670;
  zvertexweight[3]=0.104070;
  zvertexweight[4]=0.107120;
  zvertexweight[5]=0.111120;
  zvertexweight[6]=0.108880;
  zvertexweight[7]=0.103670;
  zvertexweight[8]=0.096755;
  zvertexweight[9]=0.093977;
  zvertexmaxweight=zvertexweight[5];
  for(ivertex=0;ivertex<NVERTEXBINS;ivertex++){
    zvertexweight[ivertex]=zvertexweight[ivertex]/zvertexmaxweight;
  }

  zvertexmin=-75.0;
  zvertexmax=75.0;
  NETABINS=100;
  etamin=-1.5;
  etamax=1.5; 

  acceptprob=new double*[NETABINS];
  for(ivertex=0;ivertex<NVERTEXBINS;ivertex++)
    acceptprob[ivertex]=new double[NETABINS];

  delzvertex=(zvertexmax-zvertexmin)/double(NVERTEXBINS);
  deleta=(etamax-etamin)/double(NETABINS);

  for(ivertex=0;ivertex<NVERTEXBINS;ivertex++){
    sst << "../staracceptance/hist/etahist_c" << icentrality
	<< "_v" << ivertex << ".txt" << ends;
    sst >> filename;
    infile.open(filename.c_str());
    cout << "Opening " << filename << endl;
    for(ieta=0;ieta<NETABINS;ieta++){
      infile >> eta >> dndeta >> acceptprob[ivertex][ieta];
      //cout << form("%d %d %g\n",ivertex,ieta,acceptprob[ivertex][ieta]);
    }
    infile.close();
  }
}

bool Tstaracceptance::pass(double zvertex,double *p){
  int ieta,ivertex;
  int answer;
  double eta,pt,pmag;

  pt=p[1]*p[1]+p[2]*p[2];
  pmag=sqrt(p[3]*p[3]+pt);
  pt=sqrt(pt);
  eta=0.5*log((pmag+p[3])/(pmag-p[3]));

  ivertex=int(double(NVERTEXBINS)*(zvertex-zvertexmin)
	      /(zvertexmax-zvertexmin));
  ieta=int((eta-etamin)/deleta);
  answer=0;
  if(ivertex>=0 && ieta >=0 && ivertex < NVERTEXBINS && ieta < NETABINS){
    if(pmag<700.0 && fabs(eta)<1.3){
      if(ranptr->ran()<acceptprob[ivertex][ieta]) answer=1;
    }
  }
  return answer;
}

double Tstaracceptance::getzvertex(){
  int ivertex;
  double zvertex;
 TRY_AGAIN:
  //zvertex=zvertexmin+(zvertexmax-zvertexmin)*ranptr->ran();
  zvertex=-25.0+50.0*ranptr->ran();
  ivertex=int(double(NVERTEXBINS)*(zvertex-zvertexmin)
	      /(zvertexmax-zvertexmin));
  if(zvertexweight[ivertex]<ranptr->ran()) goto TRY_AGAIN;
  return zvertex;
}
